#
# $Id: loglog.rb,v 1.3 1999/08/24 06:25:24 cvs Exp $
# $Author: cvs $
# $Date: 1999/08/24 06:25:24 $
#

=begin

$B%F%-%9%H$r%U%!%$%k$KJ]B8$9$k>l9g$K!">u67$K1~$8$FE,@Z$JBP1~$r$9$k$?$a$N(B
$B%W%m%0%i%`!#%U%!%$%k$N(Bover write$B$d(Bcreate$B$K4X$7$F%U%i%0$K$h$C$FBP1~$r7h$a$k!#(B

$BF~NO!'(B
	save(input_text, dir_path, file_name)
		input_text := $BJ]B8$7$?$$%U%!%$%k$NFbMF(B
		dir_path := $BAjBP(B or $B@dBP%Q%9L>(B
		file_name := $B%Q%9$r4^$^$J$$%U%!%$%kL>(B

	set_dirsep(String sep = "/")
		file_name$B$K4^$^$l$kJ8;zNs$NCf$G(Bsep$B$r%;%Q%l!<%?!<$H$9$k!#(B
		News$B5-;v$NJ]B8$J$I$N>l9g$K$O(B sep = "." $B$J$I$H$9$k$N$,JXMx!#(B

	set_overwrite(boolean write = true)
		$BF1$8%U%!%$%kL>$,$"$C$?;~$K>e=q$-$9$k$+7h$a$k!#(B
		true$B$G$O>e=q$-$5$l$k!#(B

	set_backup(boolean backup = true)
		$BF1$8%U%!%$%kL>$,B8:_$7$?;~$K>e=q$-$9$k>l9g$K$O(B
		$B%P%C%/%"%C%W$r<h$k!#(Bfalse$B$G$O%P%C%/%"%C%W$O(B
		$B:n@.$5$l$J$$!#(B

$B=PNO(B($BF0:n(B)$B!'(B
	$B%G%U%)%k%H$H(Bset_xxx()$B%a%=%C%I$N;X<($K$7$?$,$C$F(B
	$B%F%-%9%H$r%U%!%$%k$KJ];}$9$k(B
=end

class LOGLOG
  def initialize
    @home = Dir.pwd
    @sep = "/"
    @write = true
    @backup = true
  end

  # main$B$NF0:n(B
  def save(input_text, dir_path, file_name)
    # path $B$rE,@Z$J7A$KE83+$7$FFbIt$GJ];}$9$k(B
    path = dir_path.gsub(@sep, "/")
    name = String(file_name)

    # create dirs
    path.split('/').each { |dir|
      if ! FileTest.exist?(dir)
	Dir.mkdir(dir)
      end
      Dir.chdir(dir)
    } # for that above action, we can save file into the correct dir
    
    # save the text info the file
    if FileTest.exist?(name)
      if @write == true and @backup == true
	# make backup
	File.rename name, name + ".bak"
      elsif @write == true and @backup == false
	# remove file
	File.delete name
      elsif @write == false
	Dir.chdir(@home) # finally, go home ;-)
	raise "Cannot save text as the given file name"
      end
    end
    file = File.open(name,"w")
    file.write(input_text)
    file.close

    Dir.chdir(@home) # finally, go home ;-)
  end

  # modify actions
  def set_dirsep(sep = "/")
    @sep = Regexp.quote(String(sep))
  end
  def set_overwrite(write = true)
    @write = write
  end
  def set_backup(backup = true)
    @backup = backup
  end
end

## DEBUG MODE
# usage: env DEBUG="" ruby loglog.rb
require "Env"
if ENV["DEBUG"]
  text = "Hello"
  path = "u-aizu.test.test1.test2"
  file = "1"

  log = LOGLOG.new
  log.set_dirsep(".")
  log.set_backup(false)
  log.save(text, path, file)
end
## END DEBUG MODE
